using System.ServiceModel;
using System.ServiceModel.Web;

namespace Example.WcfServiceHost
{
    [ServiceContract]
    public interface IInsultService
    {
        [OperationContract]
        [WebGet(RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml,
            BodyStyle = WebMessageBodyStyle.Bare,
            UriTemplate = "/insult/{personToInsult}")]
        Insult GetInsult(string personToInsult);

        [OperationContract]
        [WebInvoke(RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml,
            BodyStyle = WebMessageBodyStyle.Bare,
            UriTemplate = "/insult/Add/{insultName}/{insultText}", 
            Method = "POST")]
        void AddInsult(string insultName, string insultText);

        [OperationContract]
        [WebInvoke(RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml,
            BodyStyle = WebMessageBodyStyle.Bare,
            UriTemplate = "/insult/delete/{insultName}",
            Method = "DELETE")]
        void DeleteInsult(string insultName); 
    }
}