using System.Runtime.Serialization;

namespace Example.WcfServiceHost
{
    /// <summary>
    /// A simple class that defines an insult. 
    /// </summary>
    [DataContract]
    public class Insult
    {
        /// <summary>
        ///  The actual text of the insult: 
        /// <remarks>The example would output the following 
        /// when "Donn" was passed into the method: "Donn, yo mama is soooo ... ". An ordinal is not 
        /// necessary. But if you would like the name to show up, then put one in.</remarks>
        /// <example>{0}, yo mama is soooo ... </example>
        /// </summary>
        [DataMember]
        public string InsultText { get; set; }

        /// <summary>
        /// The name of the insult. This is so we can keep track of them.
        /// </summary>
        [DataMember]
        public string InsultName { get; set; }
    }
}