using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;
using System.Security.Cryptography;

namespace Example.WcfServiceHost
{
    /// <summary>
    /// A class that generates insults. 
    /// </summary>
    public class InsultGenerator
    {
        private List<Insult> insults;
        FileInfo fileInfo = new FileInfo(AppDomain.CurrentDomain.BaseDirectory + "\\InsultService\\Insults.txt");

        public InsultGenerator(List<Insult> insults)
        {
            this.insults = insults;
        }

        public InsultGenerator()
        {
            insults = LoadInsultsFromRepository();
       }

        private List<Insult> LoadInsultsFromRepository()
        {
            List<Insult> fileInsults = new List<Insult>();

            // A cheap attempt to load some insults from a file.
            string[] insultsFromFile = GetInsultFileContents();

            foreach (var insult in insultsFromFile)
            {
                string[] tokenizedInsult = insult.Split('|');
                var finalInsult = new Insult()
                                      {
                                          InsultName = tokenizedInsult[0],
                                          InsultText = tokenizedInsult[1]
                                      };
                fileInsults.Add(finalInsult);
            }

            return fileInsults; 
        }

        /// <summary>
        /// Gets the contents of the insults file.
        /// </summary>
        /// <returns></returns>
        private string[] GetInsultFileContents()
        {
            
            return File.ReadAllLines(fileInfo.FullName);
        }

        public Insult GetInsult(string nameOfPersonToInsult)
        {
            Random rnd = new Random();
            int cheapRandomInsult = rnd.Next(0, insults.Count);
            var insult = insults[cheapRandomInsult];
            insult.InsultText = insult.InsultText.Replace("{0}", nameOfPersonToInsult);
            return insult; 
        }

        public void AddInsult(Insult insult)
        {
            File.AppendAllText(fileInfo.FullName, Environment.NewLine + insult.InsultName + "|" + insult.InsultText); 
        }

        public void DeleteInsult(string insultName)
        {
            List<Insult> insultFileContents = LoadInsultsFromRepository();

            Insult insult = insultFileContents.First(ins => ins.InsultName == insultName);
            if (insult != null)
            {
                insults.Remove(insult); 
            }
        }
    }
}